unit uconsulta_lazarus;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, Buttons, DB, sqlite3conn, sqldb,
  DBCtrls, Grids, DBGrids,MaskEdit, UITYpes;

const
  //ALERTAS
  ERRO_SRV    = 'Erro inicializando servidor.';
  START_SRV   = 'Servidor inicializado com sucesso.';
  STOP_SRV    = 'Servidor interrompido.';

  SQLITEDB    = 'DBProdutos.sdb';
  //versao 1..0.0.2
  //CRIATABLE   = 'CREATE TABLE "Produtos" ("BarCode"     Char(50),"Produto"     Char(20),"Preco"       Currency )';
  //CRIATABLE   = 'CREATE TABLE "Produtos" ("BarCode"     Char(50),"Produto"     Char(50),"Preco"       Currency )';
  CRIATABLE   = 'CREATE TABLE "Produtos" ("BarCode"     Char(50),"Produto"     Char(50),"Preco"       Currency, "Linha3" Cha(50), "Linha4" Char(50) )';
  {$IFDEF WIN64}
  VP_DLL      = 'VP_v3_x64.DLL';
  {$ELSE}
  VP_DLL      = 'VP_v3.DLL';
  {$ENDIF}

type TIPV4 = record
  d,c,b,a: byte;
end;

type stAddress = record
  Ip    : PAnsiChar;
  Socket: Word;
end;

type
  TTABSOCK = record
    TabSock: array[0..1023] of Word;
    TabIP: array[0..1023] of DWORD;
    NumSockConec: integer;
end;

type

  { TFConsulta }

  TFConsulta = class(TForm)
    DBNavigator2: TDBNavigator;
    SQLiteConn: TSQLite3Connection;
    queryFD: TSQLQuery;
    TransactionFD: TSQLTransaction;
    TabMensagens: TTabSheet;
    TabProdutos: TTabSheet;
    Panel1: TPanel;
    TabMonitora: TTabSheet;
    BtnMonitora: TBitBtn;
    BtnMensagens: TBitBtn;
    PC: TPageControl;
    BtnProdutos: TBitBtn;
    DSProdutos: TDataSource;
    Image1: TImage;
    ListTerms: TListBox;
    Timer100ms: TTimer;
    Timer3Seg: TTimer;
    TxtConectados: TStaticText;
    GridProdutos: TDBGrid;
    StaticText2: TStaticText;
    MemoRecv: TMemo;
    BtnIniciar: TBitBtn;
    BtnLimparMemo: TButton;
    EdtPesquisar: TEdit;
    BtnPesquisar: TBitBtn;
    GrpIMsg: TGroupBox;
    LabLine1: TLabel;
    LabLine2: TLabel;
    LabTimeEx: TLabel;
    EdtLine1: TEdit;
    EdtLine2: TEdit;
    EdtTimeEx: TEdit;
    BtnMsgSend: TButton;
    EdtImportar: TEdit;
    BtnOpenFile: TBitBtn;
    BtnImportar: TBitBtn;
    OpenFile: TOpenDialog;
    LblArquivo: TLabel;
    BtnApagar: TBitBtn;
    LblContador: TLabel;
    Label1: TLabel;
    EditUnidMon: TLabeledEdit;
    procedure BtnMonitoraClick(Sender: TObject);
    procedure BtnMensagensClick(Sender: TObject);
    procedure BtnProdutosClick(Sender: TObject);
    procedure BtnIniciarClick(Sender: TObject);
    procedure BtnLimparMemoClick(Sender: TObject);
    procedure BtnPesquisarClick(Sender: TObject);
    procedure BtnMsgSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListTermsClick(Sender: TObject);
    procedure Timer100msTimer(Sender: TObject);
    procedure Timer3SegTimer(Sender: TObject);
    procedure BtnImportarClick(Sender: TObject);
    procedure BtnOpenFileClick(Sender: TObject);
    procedure BtnApagarClick(Sender: TObject);

  private
    { Private declarations }
    function CarregaDLL: Boolean;
    function GetEXEVersionData(const FileName: string): String;
  public
    { Public declarations }
    TabTerms: TTABSOCK;

  end;
var
  FConsulta: TFConsulta;
  SelTerm: integer;


var
//------------------------------------------------------------------------------
//dll_v3
{
  procedure vInitialize; stdcall; far;
  function  tc_startserver: integer; stdcall; far;
  function  GetTabConectados(nada: integer): TTABSOCK; stdcall; far;
  function  bConnected(out ID_WIp: DWORD; out ID_Socket: integer): boolean; far;
  function  bDisconnected(out ID_WIp: DWORD; out ID_Socket: integer): boolean; far;
  function  bCloseTerminal(ID_Ip: DWORD; ID_Socket: integer): boolean; far; stdcall;
  function  Inet_NtoA(nIP: DWORD): PAnsiChar; far; stdcall;
  function  Inet_Addr(sIP: PAnsiChar): DWORD; far; stdcall;
  function  bSendDisplayMsg(ID: DWORD; Linha1: PAnsiChar; Linha2: PAnsiChar;
  function  bReceiveBarcode(out ID_IP: DWORD; out ID_Socket: integer; out Nbr: integer): PAnsiChar; stdcall; far;
  function  bSendProdNotFound(ID: DWORD): boolean; far; stdcall;
  function  bSendProdPrice(ID: DWORD; NameProd: PAnsiChar; PriceProd: PAnsiChar):
  function  dll_version: PAnsiChar; stdcall; far;
  function  bTerminate: boolean; far; stdcall;
}
  GetTabConectados  : function  (nada: integer): TTABSOCK; stdcall = nil;
  Inet_NtoA         : function  (nIP: DWORD): PAnsiChar; stdcall = nil;
  vInitialize       : procedure ; stdcall = nil;
  tc_startserver    : function  : integer; stdcall = nil;
  bTerminate        : function  : boolean; stdcall = nil;
  bSendDisplayMsg   : function  (ID: DWORD; Linha1: PAnsiChar; Linha2: PAnsiChar; Tempo: Integer): Boolean; stdcall = nil;
  bSendProdNotFound : function  (ID: DWORD): boolean;stdcall = nil;
  bSendProdPrice    : function  (ID: DWORD; NameProd: PAnsiChar; PriceProd: PAnsiChar): Boolean; stdcall = nil;
  bReceiveBarcode   : function  (out ID_IP: DWORD; out ID_Socket: Word; out Nbr: integer): PAnsiChar; stdcall = nil;
  bConnected        : function  (out ID_WIp: DWORD; out ID_Socket: Word): boolean; stdcall = nil;
  bDisconnected     : function  (out ID_WIp: DWORD; out ID_Socket: Word): boolean; stdcall = nil;
  bCloseTerminal    : function  (ID_Ip: DWORD; ID_Socket: Word): boolean; stdcall = nil;
  Inet_Addr         : function  (sIP: PAnsiChar): DWORD; stdcall = nil;
  dll_version       : function  : PAnsiChar; stdcall = nil;

//------------------------------------------------------------------------------

implementation

{$R *.lfm}

procedure TFConsulta.BtnApagarClick(Sender: TObject);
var
  botaoSelecionado: integer;
begin
  Lblcontador.Visible := false;
  botaoSelecionado := MessageDlg('Atenção:' + chr(10) + chr(13)
       + 'Esta ação apagará todos os itens da base de dados.' + chr(10) + chr(10)
       + chr(13) + 'Clique OK para continuar.', mtConfirmation, mbOKCancel, 0);
  if (botaoSelecionado = mrOK) then
  begin
    queryFD.Close;
    queryFD.SQL.Clear;
    queryFD.SQL.Add('delete from produtos');
    queryFD.ExecSQL;
    queryFD.SQL.Clear;
    queryFD.SQL.Add('SELECT * FROM PRODUTOS ORDER BY PRODUTO');
    queryFD.Open;
    ShowMessage('Todos os itens foram apagados.');
  end;
end;

procedure TFConsulta.BtnImportarClick(Sender: TObject);
var
  FDB: TextFile;
  StrAux: string;
  txtBarcode: string;
  txtProduto: string;
  txtPreco: string;
  LengthPreco: integer;
  contador: integer;
begin
  contador:= 0;
  Lblcontador.Caption := IntToStr(contador);
  Lblcontador.Visible := true;
  Screen.Cursor := crHourGlass;
  if (EdtImportar.Text <> '') then
  begin
    AssignFile(FDB,EdtImportar.Text);
    Reset(FDB);
    if (IOResult=0) then begin
      queryFD.Edit;
      while (not(eof(FDB))) do
      begin
        Readln(FDB,StrAux);
        if (StrAux[14] = '|') then
        begin
          txtBarCode := Copy(StrAux,1,13);
          txtProduto := Copy(StrAux,15,20);
          txtPreco := Trim(Copy(StrAux,36,20));
        end else
        if (StrAux[29] = '|') then
        begin
          txtBarCode := Copy(StrAux,1,28);
          txtProduto := Copy(StrAux,30,20);
          txtPreco := Trim(Copy(StrAux,52,20));
        end;

        LengthPreco := Length(txtPreco);
        if (queryFD.Locate('BarCode',txtBarCode,[])) then
        begin
          queryFD.Edit;
          queryFD.Fields.FieldByName('Produto').AsString := txtProduto;
          if (Copy(txtPreco, LengthPreco-2, 1) = ',') then
          begin
            queryFD.Fields.FieldByName('Preco').AsString := txtPreco
          end else
          if (Copy(txtPreco, LengthPreco-2, 1) = '.') then
          begin
            queryFD.Fields.FieldByName('Preco').AsString := Copy(txtPreco,1, LengthPreco-3) +
                    ',' +
                    Copy(txtPreco, LengthPreco-1, 2);
          end else begin
            queryFD.Fields.FieldByName('Preco').AsString := Copy(txtPreco,1, LengthPreco-2) +
                    ',' +
                    Copy(txtPreco, LengthPreco-1, 2);
          end;
          inc(contador);
          Lblcontador.Caption := IntToStr(contador);
          //---Application.ProcessMessages;
        end else begin
          queryFD.Append;
          queryFD.Fields.FieldByName('BarCode').AsString := txtBarCode;
          queryFD.Fields.FieldByName('Produto').AsString := txtProduto;
          if (Copy(txtPreco, LengthPreco-2, 1) = ',') then
          begin
            queryFD.Fields.FieldByName('Preco').AsString := txtPreco
          end else
          if (Copy(txtPreco, LengthPreco-2, 1) = '.') then
          begin
            queryFD.Fields.FieldByName('Preco').AsString := Copy(txtPreco,1, LengthPreco-3) +
                    ',' +
                    Copy(txtPreco, LengthPreco-1, 2);
          end else begin
            queryFD.Fields.FieldByName('Preco').AsString := Copy(txtPreco,1, LengthPreco-2) +
                    ',' +
                    Copy(txtPreco, LengthPreco-1, 2);
          end;
          inc(contador);
          Lblcontador.Caption := IntToStr(contador);
          //---Application.ProcessMessages;
        end;
        Application.ProcessMessages;
      end;
//---
      queryFD.Post;
      CloseFile(FDB);
      ShowMessage('Importacao de dados conluida!');
    end;
  end else begin
      ShowMessage('Selecione o arquivo a ser importado.');
      BtnOpenFile.SetFocus;
  end;
  Screen.Cursor := crDefault;

end;

procedure TFConsulta.BtnIniciarClick(Sender: TObject);
begin
  if (BtnIniciar.Caption = 'Parar') then
  begin
    if (bTerminate = true) then
    begin
      MemoRecv.Lines.Add(STOP_SRV);
      Timer3seg.Enabled := false;
      Timer100ms.Enabled := false;
      BtnIniciar.Caption := 'Iniciar';
      BtnMonitora.Font.Color := clRed;
      BtnMensagens.Enabled := False;
    end else begin
      MemoRecv.Lines.Add(ERRO_SRV);
      ShowMessage(ERRO_SRV);
    end;
  end else begin
    if (tc_startserver <> 0) then begin
      MemoRecv.Lines.Add(START_SRV);
      BtnIniciar.Caption := 'Parar';
      BtnMonitora.Font.Color := clGreen;
      BtnMensagens.Enabled := True;
      ListTerms.Clear;
      Timer3seg.Enabled := true;
      Timer100ms.Enabled := true;
    end else begin
      MemoRecv.Lines.Add(ERRO_SRV);
      Timer3seg.Enabled := false;
      Timer100ms.Enabled := false;
      ShowMessage(ERRO_SRV);
    end;
  end;
end;

procedure TFConsulta.BtnLimparMemoClick(Sender: TObject);
begin
  MemoRecv.Clear;
end;

procedure TFConsulta.BtnMensagensClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 1;
end;

procedure TFConsulta.BtnMonitoraClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 0;
end;

procedure TFConsulta.BtnMsgSendClick(Sender: TObject);
var
  Lin1: PAnsiChar;
  Lin2: PAnsiChar;
  Selected: String;
  Position: Integer;
  ID: stAddress;
begin
  Lin1:= PAnsichar(EdtLine1.Text);
  Lin2:= PAnsichar(EdtLine2.Text);
  if (ListTerms.ItemIndex < 0) then
  begin
    ShowMessage('Selecione um Terminal');
  end else begin
    Selected := ListTerms.Items.Strings[ListTerms.ItemIndex];
    Position := LastDelimiter(':', Selected);
    ID.Ip:= PAnsiChar(AnsiString(Copy(Selected,1,Position - 1)));
    ID.Socket:= StrToInt(Copy(Selected,Position+1,Length(Selected) - Position));
    bSendDisplayMsg(inet_Addr(ID.Ip),
                  Lin1,
                  Lin2,
                  StrToInt(EdtTimeEx.Text)
                  );
    MemoRecv.Lines.Add(String(ID.Ip) + ':' + IntToStr(ID.Socket) + ' -> ' +
      'Mensagem enviada ao Terminal');
  end;
end;


procedure TFConsulta.BtnOpenFileClick(Sender: TObject);
begin
  BtnImportar.Enabled := false;
  EdtImportar.Text := '';
  OpenFile.Title := 'Abrir Arquivo para importação';
  if OpenFile.Execute then
  begin
    EdtImportar.Text := OpenFile.FileName;
    BtnImportar.Enabled := true;
    LblContador.Visible := false;
  end;
end;

procedure TFConsulta.BtnPesquisarClick(Sender: TObject);
begin
  Lblcontador.Visible := false;
  if (EdtPesquisar.Text = '') then
  begin
    ShowMessage('Por favor, entre com o Código do produto.');
  end else begin
    if (queryFD.Locate('BarCode', Trim(EdtPesquisar.Text), [])) then
    begin
      ShowMessage('Produto: ' + queryFD.FieldByName('Produto').AsString);
    end else begin
      ShowMessage('Codigo do produto nao consta na Base de Dados.');
    end;
  end;
end;

procedure TFConsulta.BtnProdutosClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 2;
end;

procedure TFConsulta.FormCreate(Sender: TObject);
  var
  Parte:  TStringList;
  ExeVer: String;
begin
  Exever := '';
  try
     ExeVer := GetEXEVersionData(Application.ExeName);
  except
  end;
  {$IFDEF WIN64}
  FConsulta.Caption := 'Tanca - Sistema de Consulta de  Preços (Versão: '+ExeVer+' x64_lz)';
  {$ELSE}
  FConsulta.Caption := 'Tanca - Sistema de Consulta de  Preços (Versao: '+ExeVer+' x86_lz)';
  {$ENDIF}

  if (CarregaDLL = false) then
  begin
    Application.Terminate;
    exit;
  end;

  SelTerm:= -1;
  FConsulta.PC.ActivePageIndex := 0;
  vInitialize;
  MemoRecv.Lines.Add('Versão da DLL: ' + String(dll_version));
  BtnMonitora.Font.Color := clRed;
  BtnMensagens.Enabled := False;
  LblContador.Visible := false;

  SQLiteConn.LoginPrompt := False;
  SQLiteConn.DataBaseName := ExtractFilePath(ParamStr(0)) + SQLITEDB;
  SQLiteConn.Connected := True;
  SQLiteConn.Transaction := TransactionFD;

  TransactionFD.Database := SQLiteConn;

  queryFD.Database := SQLiteConn;
  queryFD.Transaction := TransactionFD;
  queryFD.Options  := [sqoKeepOpenOnCommit, sqoAutoApplyUpdates, sqoAutoCommit];
  queryFD.UpdateMode := upWhereAll;

  DSProdutos.AutoEdit := False;
  DSProdutos.DataSet := queryFD;

  Parte := TStringList.Create;
  Parte.Clear;
  SQLiteConn.GetTableNames(Parte);
  if (Parte.Count < 1) then
  begin
    queryFD.Close;
    queryFD.SQL.Clear;
    queryFD.SQL.Add(CRIATABLE);
    queryFD.ExecSQL;
    TransactionFD.Commit;
    Parte.Clear;
    SQLiteConn.GetTableNames(Parte);
    if (Parte.Count < 1) then
    begin
      ShowMessage('Falha na criação do DB.');
      Parte.Free;
      Application.Terminate;
    end else begin
      ShowMessage('DB criado com sucesso.');
      Parte.Free;
    end;

  end;

  queryFD.SQL.Clear;
  queryFD.SQL.Add('SELECT * FROM PRODUTOS ORDER BY PRODUTO');
  queryFD.Open;
  queryFD.Active := true;
  DSProdutos.Enabled := true;
  GridProdutos.Columns[0].Width := 120;
  GridProdutos.Columns[1].Width := 225;
  GridProdutos.Columns[2].Width := 85;

  if ParamCount > 0 then
  begin
    if (uppercase(ParamStr(1)) = '/AUTO') then
    begin
      BtnIniciar.Click;   //iniciando o serviço no statup
    end;
  end;

end;

procedure TFConsulta.ListTermsClick(Sender: TObject);
var
  i : integer;
begin
  with (Sender as TListBox) do begin
    i := ItemIndex-1;
    repeat
      inc(i);
      SelTerm := TabTerms.TabSock[i];
    until (TabTerms.TabSock[i]<>0) or (i>1023);
  end;
end;

procedure TFConsulta.Timer100msTimer(Sender: TObject);
var
  ID_Ip: DWORD;
  ID_Socket:  Word;
  Nbr : integer;
  BarCode: PAnsiChar;
  produto: PAnsiChar;
  preco: PAnsiChar;
  precoStr: String;
  preco_curr: String;
  length_preco_curr: integer;
  StrBarCode: String;
begin
  BarCode := bReceiveBarcode(ID_Ip, ID_Socket, Nbr);
  StrBarCode := String(BarCode);
  if (StrBarCode <> '') then
  begin
    if (queryFD.Locate('BarCode',StrBarCode,[])) then
    begin
     produto := PAnsiChar(queryFD.FieldByName('Produto').AsString);

     preco_curr:= queryFD.FieldByName('Preco').AsString;
     length_preco_curr:= Length(preco_curr);
     if (preco_curr[length_preco_curr-2] = ',') then
     begin
        precoStr := PAnsiChar(Trim(EditUnidMon.Text) + ' ' + queryFD.FieldByName('Preco').AsString);
     end else
     //1.0.0.3
     if (preco_curr[length_preco_curr-1] = ',') then
     begin
        precoStr := Trim(EditUnidMon.Text) + ' ' + queryFD.FieldByName('Preco').AsString + '0';
     end else begin
        precoStr := Trim(EditUnidMon.Text) + ' ' + queryFD.FieldByName('Preco').AsString + ',00';
     end;
     if (Trim(queryFD.FieldByName('Linha3').AsString) <> '') then
     begin
       precoStr := precoStr + '|' + Trim(queryFD.FieldByName('Linha3').AsString);
       if (Trim(queryFD.FieldByName('Linha4').AsString) <> '') then
       begin
         precoStr := precoStr + '|' + Trim(queryFD.FieldByName('Linha4').AsString);
       end;
     end else
     if (Trim(queryFD.FieldByName('Linha4').AsString) <> '') then
     begin
       precoStr := precoStr + '||' + Trim(queryFD.FieldByName('Linha4').AsString);
     end;
     preco := PAnsiChar(precoStr);
//1.0.0.3
     bSendProdPrice(ID_Ip, produto , preco);
     MemoRecv.Lines.Add(Inet_NtoA(ID_Ip) + ':' + IntToStr(ID_Socket) + ' -> ' +
      StrBarcode + '|' + String(Produto) + '|' + String(Preco));
    end else begin
      bSendProdNotFound(ID_Ip);
      MemoRecv.Lines.Add(Inet_NtoA(ID_Ip) + ':' + IntToStr(ID_Socket) + ' -> ' +
          StrBarcode + '|' + 'PRODUTO NAO ENCONTRADO');
    end;
  end;
end;

procedure TFConsulta.Timer3SegTimer(Sender: TObject);
var
  i: integer;
  sIP: PAnsiChar;
  SelTermBkp: integer;
  IdxLista: integer;

begin
  SelTermBkp:= -1;
  TabTerms := GetTabConectados(1);
  ListTerms.Clear;
  IdxLista := 0;
  for i:= 0 to TabTerms.NumSockConec-1 do
  begin
    if TabTerms.TabIP[i] <> 0 then
    begin
      sIP:= Inet_NtoA(TabTerms.TabIP[i]);
      if ((TabTerms.TabSock[i] = SelTerm) and (SelTermBkp = -1)) then
      begin
        SelTermBkp := IdxLista;
      end;
      inc(IdxLista);
      ListTerms.Items.Add(String(sIP) + ':' + IntToStr(TabTerms.TabSock[i]));
    end;
  end;
  ListTerms.ItemIndex := SelTermBkp;
  if (SelTermBkp = -1) then SelTerm := 0;
end;

function TFConsulta.CarregaDLL: Boolean;
var
  DLLHandle: cardinal;
  _DLL: String;
  ErrorMode: UINT;
const
  CRLF = chr(10)+chr(13);
begin
  _DLL := ExtractFilePath(Application.ExeName) + VP_DLL;
  if (fileexists(ExtractFilePath(Application.ExeName) + VP_DLL)) then
  begin
    if (DLLHandle > 32) then
    begin
      FreeLibrary(DLLHandle);
    end;
    ErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS); // disable OS error messages
    try
      DLLHandle := LoadLibrary(PAnsiChar(_DLL));
    finally
      SetErrorMode(ErrorMode);
    end;

    ErrorMode := SetErrorMode(0); // enable OS error messages

    if (DLLHandle <= 32) then
    begin
      MessageBox(0, PAnsiChar('Erro ao carregar a DLL: ' + _DLL), 'Erro!', MB_OK);
      result := false;
    end
    else
    begin
//------------------------------------------------------------------------------
      //dll_v3
      GetTabConectados  := GetProcAddress(DLLHandle, 'GetTabConectados');
      Inet_NtoA         := GetProcAddress(DLLHandle, 'Inet_NtoA');
      vInitialize       := GetProcAddress(DLLHandle, 'vInitialize');
      tc_startserver    := GetProcAddress(DLLHandle, 'tc_startserver');
      dll_version       := GetProcAddress(DLLHandle, 'dll_version');
      bTerminate        := GetProcAddress(DLLHandle, 'bTerminate');
      bSendDisplayMsg   := GetProcAddress(DLLHandle, 'bSendDisplayMsg');
      bSendProdNotFound := GetProcAddress(DLLHandle, 'bSendProdNotFound');
      bSendProdPrice    := GetProcAddress(DLLHandle, 'bSendProdPrice');
      bReceiveBarcode   := GetProcAddress(DLLHandle, 'bReceiveBarcode');

      bConnected        := GetProcAddress(DLLHandle, 'bConnected');
      bDisconnected     := GetProcAddress(DLLHandle, 'bDisconnected');
      bCloseTerminal    := GetProcAddress(DLLHandle, 'bCloseTerminal');
      Inet_Addr         := GetProcAddress(DLLHandle, 'Inet_Addr');
//------------------------------------------------------------------------------

      result := true;
    end;
  end else begin
    MessageBox(0, PAnsiChar(_DLL + ' nao esta presente'), 'Erro!', MB_OK);
    result := false;
  end;
end;

function TFConsulta.GetEXEVersionData(const FileName: string): String;
type
  PLandCodepage = ^TLandCodepage;
  TLandCodepage = record
    wLanguage,
    wCodePage: word;
  end;
var
  dummy,
  len: cardinal;
  buf, pntr: pointer;
  lang: string;
begin
  len := GetFileVersionInfoSize(PChar(FileName), dummy);
  if len = 0 then
    RaiseLastOSError;
  GetMem(buf, len);
  try
    if not GetFileVersionInfo(PChar(FileName), 0, len, buf) then
      RaiseLastOSError;

    if not VerQueryValue(buf, '\VarFileInfo\Translation\', pntr, len) then
      RaiseLastOSError;

    lang := Format('%.4x%.4x', [PLandCodepage(pntr)^.wLanguage, PLandCodepage(pntr)^.wCodePage]);

    if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\FileVersion'), pntr, len){ and (@len <> nil)} then
       result := PChar(pntr);
  finally
    FreeMem(buf);
  end;
end;

end.
